package com.zacharcher.juliatile {

/**
 *	Class description.
 *
 *	@langversion ActionScript 3.0
 *	@playerversion Flash 9.0
 *
 *	@author Chaz Hazeltine
 *	@since  25.12.2008
 */
import mx.controls.*;

import com.zacharcher.math.*;

public class Oscillator extends Object {
	
	//--------------------------------------
	// CLASS CONSTANTS
	//--------------------------------------
	
	//--------------------------------------
	//  CONSTRUCTOR
	//--------------------------------------
	
	/**
	 *	@constructor
	 */
	public function Oscillator( inSlider:HSlider, inMin:Number=0.0, inMax:Number=1.0 )
	{
		super();
		_slider = inSlider;
		step = newStepValue * (Rand.maybe ? 1 : -1);
		
		_min = inMin;
		_max = inMax;
	}
	
	//--------------------------------------
	//  PRIVATE VARIABLES
	//--------------------------------------
	private var _slider :HSlider;
	public var step:Number;
	private var _min :Number;
	private var _max :Number;
	
	//--------------------------------------
	//  GETTER/SETTERS
	//--------------------------------------
	private function get newStepValue() :Number { return Rand.float(0.0015,0.007); }
	
	//--------------------------------------
	//  PUBLIC METHODS
	//--------------------------------------
	public function tick() :void {
		// Get the slider's current position as a range from 0..1
		var pos:Number = (_slider.value-_slider.minimum) / (_slider.maximum-_slider.minimum);
		pos += step;
		if( pos > _max ) {
			pos = _max;
			step = newStepValue * -1;
		} else if( pos < _min ) {
			pos = _min;
			step = newStepValue;
		}
		
		// Now interpolate back into the slider's range
		_slider.value = Num.interpolate( _slider.minimum, _slider.maximum, pos );
	}

	//--------------------------------------
	//  EVENT HANDLERS
	//--------------------------------------
	
	//--------------------------------------
	//  PRIVATE & PROTECTED INSTANCE METHODS
	//--------------------------------------
	
}

}

